local playerGUID = UnitGUID("player")
local f = CreateFrame("Frame")


f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:SetScript("OnEvent", function(self, event)
    self:OnEvent(event, CombatLogGetCurrentEventInfo())
end)


function Set(list)
    local set = {}
    for _, l in ipairs(list) do set[l] = true end
    return set
end

-- Build Spell list (this ignores ranks)
local buff_list = Set{
    (GetSpellInfo(5231)), --Mark of the Wild
    (GetSpellInfo(467)), --Thorns
    (GetSpellInfo(1459)), --Arcane Intellect
    (GetSpellInfo(19834)), --Blessing Of Might
    (GetSpellInfo(20217)), --Blessing Of Kings
    (GetSpellInfo(19742)), --Blessing Of Wisdom
    (GetSpellInfo(1243)), --Power Word: Fortitude
    (GetSpellInfo(5697)), --Unending Breath
    -- (GetSpellInfo(1243).slice(0,-1)), -- cause it to bug out to see table
}

function f:OnEvent(event, ...)
    local _, subevent, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
    local spell_name, _, aura_type = select(13, ...)

    if subevent == "SPELL_AURA_APPLIED" then
        -- Make sure its cast on us from another source and they are not in our raidgroup / party
        if destGUID == playerGUID then
            if not UnitInParty(sourceName) then
                if not UnitInRaid(sourcename) then
                    if sourceGUID ~= playerGUID then
                        -- Check to see if the aura is a buff and its in our list of buffs
                        if buff_list[spell_name] then
                            local type = strsplit("-", sourceGUID)
                            -- Make sure the other source is a player
                            if type == "Player" then
                                if TFTB_NEWEMOTE == nil then
                                    TFTB_NEWEMOTE = EMOTE21_TOKEN
                                end
                                DoEmote(TFTB_NEWEMOTE, sourceName)
                            end
                        end
                    end
                end
            end
        end
    end
end


SLASH_TFTB1 = "/TFTB"

local function TFTBCommands(msg, editbox)
    if msg == "" then
        print("TFTB current emote is set to " .. TFTB_NEWEMOTE .. ".")
    else
        TFTB_NEWEMOTE = msg
        print("TFTB new emote has been set to " .. TFTB_NEWEMOTE .. ".")
    end
end

SlashCmdList["TFTB"] = TFTBCommands
